org.apache.lucene.search

## Class Filter

- java.lang.Object
- - org.apache.lucene.search.Filter

- All Implemented Interfaces:
    java.io.Serializable
  Direct Known Subclasses:
    CachingWrapperFilter, FieldCacheRangeFilter, FieldCacheTermsFilter, MultiTermQueryWrapperFilter, QueryWrapperFilter, SpanFilter

      public abstract class Filter
      extends java.lang.Object
      implements java.io.Serializable

  Abstract base class for restricting which documents may be returned during searching.

  Note: In Lucene 3.0 `bits(IndexReader)` will be removed and `getDocIdSet(IndexReader)` will be defined as abstract. All implementing classes must therefore implement `getDocIdSet(IndexReader)` in order to work with Lucene 3.0.

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Filter()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.BitSet` | `bits(IndexReader reader)` Deprecated. Use `getDocIdSet(IndexReader)` instead.
    `DocIdSet` | `getDocIdSet(IndexReader reader)` Creates a `DocIdSet` enumerating the documents that should be permitted in search results.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Filter

          public Filter()

  - ### Method Detail

    - #### bits

          public java.util.BitSet bits(IndexReader reader)
                                throws java.io.IOException

      Deprecated. Use `getDocIdSet(IndexReader)` instead.
      Returns:
        A BitSet with true for documents which should be permitted in search results, and false for those that should not.

        NOTE: See `getDocIdSet(IndexReader)` for handling of multi-segment indexes (which applies to this method as well).

      Throws:
        `java.io.IOException`

    - #### getDocIdSet

          public DocIdSet getDocIdSet(IndexReader reader)
                               throws java.io.IOException

      Creates a `DocIdSet` enumerating the documents that should be permitted in search results. NOTE: null can be returned if no documents are accepted by this Filter.

      Note: This method will be called once per segment in the index during searching. The returned `DocIdSet` must refer to document IDs for that segment, not for the top-level reader.

      Parameters:
        `reader` - a `IndexReader` instance opened on the index currently searched on. Note, it is likely that the provided reader does not represent the whole underlying index i.e. if the index has more than one segment the given reader only represents a single segment.
      Returns:
        a DocIdSet that provides the documents which should be permitted or prohibited in search results. NOTE: null can be returned if no documents will be accepted by this Filter.
      Throws:
        `java.io.IOException`
      See Also:
        `DocIdBitSet`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.